unit Unit4;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, ExtCtrls;

Const
  n1 = 4  ;     // 36
  n2 = 6 ;    // 256
Type
  TLutValeur = record
       r,v,b : Byte;
  end;
  TTab1 = Array [0.. n1-1] of byte ;
  TTab2 = Array [0.. n2-1] of byte ;
  TTLut1 = Array [0.. n1-1, 0.. n1-1, 0.. n1-1] of byte ;
  TTLut2 = Array [0.. n2-1, 0.. n2-1, 0.. n2-1] of byte ;

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    Memo2: TMemo;
    Button2: TButton;
    Button1: TButton;
    Image1: TImage;
    Label1: TLabel;
    Label2: TLabel;
    Btn_Fermer: TButton;
    Label3: TLabel;
    procedure Interpoler(T1 : TTab1 ; var T2 : TTab2);
    procedure InterpolerLut(TL1 : TTLut1 ; var TL2 : TTLut2);
    procedure Button2Click(Sender: TObject);
    procedure RemplirTableLut ;
    procedure Button1Click(Sender: TObject);
    procedure Btn_FermerClick(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;
  TableLut    : array[0..n1-1,0..n1-1,0..n1-1] of TLutValeur  ;
  TableLut255 : array[0..n2-1,0..n2-1,0..n2-1] of TLutValeur ;
  T1          : TTab1 ;
  T2          : TTab2 ;
  TLut1       : TTLut1 ;
  TLut2       : TTLut2 ;
implementation

{$R *.dfm}

{ =============================================================== }
procedure TForm1.Interpoler(T1 : TTab1 ; var T2 : TTab2);
Var
  Rap : Double ;
  i, j :Integer ;
  jDeb, jFin : Integer ;
  Mess : String ;
  Affiche : Boolean ;
Begin
  Affiche := False ;
  If Affiche Then Memo1.Lines.Add('-- T1 [i] -- Interpoler -- ') ;
  For i := 0 to n1 - 1 Do
    Begin
      Mess := ' i = '+IntToStr(i) ;
      Mess := Mess+ '  -  Valeur T1 : '+ IntToStr(T1[i]) ;
      If Affiche Then Memo1.Lines.Add(Mess) ;
    End ;

  Rap := (n2-1)/(n1-1) ;
  If Affiche Then Memo2.Lines.Add('-- T2 [i] -- Interpoler -- ') ;
  T2[0] := T1[0] ;
  j := 0 ;
  Mess := ' j = '+IntToStr(j) ;
  Mess := Mess+ '  -  Valeur T2 : '+ IntToStr(T2[j]) ;
  If Affiche Then Memo2.Lines.Add(Mess) ;
  For i := 0 To n1-2 do
    Begin
      jDeb := Round(i * Rap) ;
      jFin := Round((i+1)*Rap) ;
      If (jDeb <> jFin) Then
        Begin
          For j := jDeb+1 To jFin do
            Begin
             T2[j] := Round(T1[i]+(T1[i+1]-T1[i]) *(j-jDeb)/(jFin-jDeb)) ;
              Mess := ' j = '+IntToStr(j) ;
              Mess := Mess+ '  -  Valeur T2 : '+ IntToStr(T2[j]) ;
              If Affiche Then Memo2.Lines.Add(Mess) ;
            End ;
        End
      Else
        T2[JDeb] := T1[i] ;
    End ;
end;
{ =============================================================== }
procedure TForm1.InterpolerLut(TL1 : TTLut1 ; var TL2 : TTLut2);
Var
  i, j, l, m :Integer ;
  T1 : TTab1 ;  T2 : TTab2 ;
  Mess : String ;
  Affiche : Boolean ;
begin
  Affiche := False ;
  For l := 0 To n1 - 1 Do
  For m := 0 To n1 - 1 Do
    Begin
      If Affiche Then Memo1.Lines.Add('TL1 [i, l, m]') ;
      For i := 0 To n1-1 do
        Begin
          Mess := ' i = '+IntToStr(i)+ ' l = '+IntToStr(l)+' m = '+IntToStr(m) ;
          Mess := Mess+ '  -  Valeur TL1 : '+ IntToStr(TL1[i, l, m]) ;
          If Affiche Then Memo1.Lines.Add(Mess) ;
          T1[i] := TL1[i, l, m] ;
        End ;
          Interpoler(T1, T2) ;
          If Affiche Then Memo2.Lines.Add('TL2 [i, l, m]') ;
          For j := 0 To n2-1 do
            Begin
              TL2[j, l, m] := T2[j] ;
              Mess := ' j = '+IntToStr(j)+ ' l = '+IntToStr(l)+' m = '+IntToStr(m) ;
              Mess := Mess+ '  -  Valeur TL2 : '+ IntToStr(TL2[j, l, m]) ;
              If Affiche Then Memo2.Lines.Add(Mess) ;
            End ;
    End ;
end;
{ =============================================================== }
procedure TForm1.Button2Click(Sender: TObject);
Var
  j :Integer ;
begin
  Memo1.Clear ;
  Memo2.Clear ;
  For j := 0 To n1-1 Do
    Begin
      T1[j] := 7*j ;
      Memo1.Lines.Add('i = '+InttoStr(j) +'     - T1(i) = '+IntToStr(T1[j])) ;
    End ;
  Interpoler(T1, T2) ;
  For j := 0 To n2-1 do
     Memo2.Lines.Add('j = '+InttoStr(j) +'     - T2(j) = '+IntToStr(T2[j])) ;
end;
{ =============================================================== }
procedure TForm1.RemplirTableLut ;
Var
  i, j, k : byte ;
Begin
  Randomize ;
  For i := 0 To n1-1 Do
  For j := 0 To n1-1 Do
  For k := 0 To n1-1 Do
    Begin
//      TableLut[i, j, k].r :=  Random(255) ;
      TableLut[i, j, k].r :=  1+3*i+2*j+k ;
      TableLut[i, j, k].v :=  Random(255) ;
      TableLut[i, j, k].b :=  Random(255) ;
    End ;
End ;
{ =============================================================== }
procedure TForm1.Button1Click(Sender: TObject);
Var
  i, j, k : byte ;
  Mess : String ;
  Affiche : Boolean ;
begin
  Memo1.Clear ;
  Memo2.Clear ;
  Affiche := True ;
  If Affiche Then Memo1.Lines.Add('TableLut - Composante rouge') ;
  RemplirTableLut ;
// Remplir TLUT1
  For k := 0 To n1-1 do
  For j := 0 To n1-1 Do
    Begin
      For i := 0 To n1-1 Do
        Begin
          TLut1[i, j, k] := TableLut[i, j, k].r  ;
          Mess := ' i = '+IntToStr(i)+ ' j = '+IntToStr(j)+' k = '+IntToStr(k) ;
          Mess := Mess+ '  -  Valeur r : '+ IntToStr(TableLut[i, j, k].r) ;
          If Affiche Then Memo1.Lines.Add(Mess) ;
        End ;
      If Affiche Then Memo1.Lines.Add(' ---------- ') ;
    End ;
  InterpolerLut(TLut1, TLut2);
// Remplir TableLut255
  If Affiche Then Memo2.Lines.Add('TableLut255 - Composante rouge') ;
  For k := 0 To n2-1 do
  For j := 0 To n2-1 Do
    Begin
      For i := 0 To n2-1 Do
        Begin
          TableLut255[i, j, k].r  := TLut2[i, j, k];
          Mess := ' i = '+IntToStr(i)+ ' j = '+IntToStr(j)+' k = '+IntToStr(k) ;
          Mess := Mess+ '  -  Valeur 255 r : '+ IntToStr(TableLut255[i, j, k].r) ;
          If Affiche Then Memo2.Lines.Add(Mess) ;
        End ;
      If Affiche Then Memo2.Lines.Add(' ---------- ') ;
    End ;
  //  Dbut des TMemo
  Memo1.SetFocus;
  Memo1.SelStart:=0;
  SendMessage(Memo1.Handle, EM_ScrollCaret,0,0);
  Memo2.SetFocus;
  Memo2.SelStart:=0;
  SendMessage(Memo2.Handle, EM_ScrollCaret,0,0);
  // Fin
  ShowMessage('Remplissage TableLut255 termin') ;
end;
{ =============================================================== }
procedure TForm1.Btn_FermerClick(Sender: TObject);
begin
  Close ;
end;
{ =============================================================== }
end.
